;EasyCodeName=ECTimeDriver,1
.Const

.Data

DEVICE_EXTENSION Struct
    ;This structure is driver-defined.
    ;It must be filled depending on
    ;the driver to be programmed.

    ;Until filled with necessary
    ;data, define a DD value in
    ;order to avoid GoAsm errors
    DD
EndS

.Code

DriverEntry Frame pDriverObject, pusRegistryPath
    Local usDeviceName:UNICODE_STRING, usSymbolicLinkName:UNICODE_STRING
    Local pDeviceObject:D

    Invoke RtlInitUnicodeString, Addr usDeviceName, L"\Device\ECTimeDriver"
    Invoke RtlInitUnicodeString, Addr usSymbolicLinkName, L"\DosDevices\ECTimeDriver"

    Invoke IoCreateDevice, [pDriverObject], SizeOf DEVICE_EXTENSION, Addr usDeviceName, \
                           FILE_DEVICE_UNKNOWN, 0, TRUE, Addr pDeviceObject
    Cmp Eax, STATUS_SUCCESS
    Je >
    Mov Eax, STATUS_DEVICE_CONFIGURATION_ERROR
    Ret

:   Invoke IoCreateSymbolicLink, Addr usSymbolicLinkName, Addr usDeviceName
    Cmp Eax, STATUS_SUCCESS
    Je >
    Invoke IoDeleteDevice, [pDriverObject]
    Mov Eax, STATUS_DEVICE_CONFIGURATION_ERROR
    Ret

:   Mov Eax, [pDriverObject]
    Mov [Eax + DRIVER_OBJECT.DriverUnload], Offset DriverUnload

    Mov [Eax + DRIVER_OBJECT.MajorFunction + (IRP_MJ_CREATE * 4)], Offset DriverDispatch
    Mov [Eax + DRIVER_OBJECT.MajorFunction + (IRP_MJ_CLOSE * 4)], Offset DriverDispatch
    Mov [Eax + DRIVER_OBJECT.MajorFunction + (IRP_MJ_DEVICE_CONTROL * 4)], Offset DriverDispatch
    Mov [Eax + DRIVER_OBJECT.MajorFunction + (IRP_MJ_READ * 4)], Offset DriverDispatch
    Mov [Eax + DRIVER_OBJECT.MajorFunction + (IRP_MJ_WRITE * 4)], Offset DriverDispatch

    Mov Eax, STATUS_SUCCESS
    Ret
EndF

DriverUnload Frame pDriverObject
    Local usSymbolicLinkName:UNICODE_STRING

    Invoke RtlInitUnicodeString, Addr usSymbolicLinkName, L"\DosDevices\ECTimeDriver"
    Invoke IoDeleteSymbolicLink, Addr usSymbolicLinkName

    Mov Eax, [pDriverObject]
    Invoke IoDeleteDevice, [Eax + DRIVER_OBJECT.DeviceObject]
    Ret
EndF

DriverDispatch Frame pDeviceObject, pIrp Uses Ecx, Edx
    Local Status:D, Info:D, IO_S_L:D

    Local RBufPtr:D ; RBuffer
    Local RBufLen:D ; RBuffer Len
    Local WBufPtr:D ; WBuffer
    Local WBufLen:D ; WBuffer Len

    Mov D[Info], 0H
    Mov Eax, [pIrp]
    Mov Eax, [Eax + _IRP.Tail.Overlay.CurrentStackLocation]
    Mov [IO_S_L], Eax

    Movzx Eax, W[Eax + IO_STACK_LOCATION.MajorFunction]

    Cmp Eax, IRP_MJ_CREATE
    Jne >
L2: Mov D[Status], STATUS_SUCCESS
    Jmp > L4
:   Cmp Eax, IRP_MJ_CLOSE
    Je < L2
    Cmp Eax, IRP_MJ_DEVICE_CONTROL
    Je < L2
    Cmp Eax, IRP_MJ_READ
    Jne > L3
            Mov Eax, [pIrp]
            Mov Ecx, [Eax + _IRP.UserBuffer]
            Mov [RBufPtr], Ecx                             ; BuffPtr
            Mov Eax, [IO_S_L]
            Mov Ecx, [Eax + IO_STACK_LOCATION.Parameters.Read.dwLength]
            Mov [RBufLen], Ecx  ; READ Out Buff Len
            ;--
            Mov D[Info], -1
            Cmp D[RBufLen], SizeOf TIME_FIELDS
            Jl < L2
            Invoke HalQueryRealTimeClock, [RBufPtr]
            Mov Eax, SizeOf TIME_FIELDS
            Mov [Info], Eax
            Jmp < L2
L3: Cmp Eax, IRP_MJ_WRITE
    Jne >
            Mov Eax, [pIrp]
            Move ([WBufPtr], [Eax + _IRP.UserBuffer])                             ; BuffPtr
            Mov Eax, [IO_S_L]
            Move ([WBufLen], [Eax + IO_STACK_LOCATION.Parameters.Write.dwLength]) ; WRITE Out Buff Len
            ;--
            Mov D[Info], -1
            Cmp D[WBufLen], SizeOf TIME_FIELDS
            Jl < L2
            Invoke HalSetRealTimeClock, [WBufPtr]
            Move ([Info], SizeOf TIME_FIELDS)
            ;--
    Jmp < L2
:   Mov D[Status], STATUS_NOT_IMPLEMENTED

L4: Mov Eax, [pIrp]
    Mov Ecx, [Status]
    Mov [Eax + _IRP.IoStatus.Status], Ecx
    Mov Ecx, [Info]
    Mov [Eax + _IRP.IoStatus.Information], Ecx

    ;IoCompleteRequest is suposed to be defined as fastcall,
    ;which means the first two parameters must be passed in
    ;Ecx and Edx registers. However, if those parameters are
    ;not pushed before calling the function, Windows crashes
	;and shows a blue screen (BSOD).
    Mov Edx, IO_NO_INCREMENT
    Mov Ecx, [pIrp]
    Push Edx
    Push Ecx
    Call IoCompleteRequest
    Mov Eax, [Status]
    Ret
EndF
