.Const

.Data

ECTIMEDRVTEST_MESSAGES	DD WM_CREATE, OnECTimeDrvTestCreate
						DD ECM_AFTERCREATE, OnECTimeDrvTestAfterCreate
						DD WM_COMMAND, OnECTimeDrvTestCommand
						DD WM_CLOSE, OnECTimeDrvTestClose

TIME_FIELDS Struct
     Year				DW ? ; 0000h range [1601...]
     Month				DW ? ; 0002h range [1..12]
     Day				DW ? ; 0004h range [1..31]
     Hour				DW ? ; 0006h range [0..23]
     Minute				DW ? ; 0008h range [0..59]
     Second				DW ? ; 000Ah range [0..59]
     Milliseconds		DW ? ; 000Ch range [0..999]
     Weekday			DW ? ; 000Eh range [0..6] == [Sunday..Saturday]
EndS

TMP_Buffer				DB     MAX_PATH Dup ?
TABs					DD     20 Dup ?

TAB						DB     09, 00, 00

hFile					DD		0

hList					DD		0
Y_hwnd					DD		0
MO_hwnd					DD		0
D_hwnd					DD		0
H_hwnd					DD		0
MI_hwnd					DD		0
S_hwnd					DD		0

TF						TIME_FIELDS
S_T						SYSTEMTIME

.Code

ECTimeDrvTestProcedure Frame hWnd, uMsg, wParam, lParam
	Mov Eax, [uMsg]
	Mov Ecx, SizeOf ECTIMEDRVTEST_MESSAGES / 8
	Mov Edx, Addr ECTIMEDRVTEST_MESSAGES
:	Dec Ecx
	Js > L2
	Cmp [Edx + Ecx * 8], Eax
	Jne <
	Call [Edx + Ecx * 8 + 4]
	Ret
L2:	Xor Eax, Eax	;Return (FALSE)
	Ret
EndF

OnECTimeDrvTestCreate:
	UseData ECTimeDrvTestProcedure
	;==================================
	;Write the initialization code here
	;==================================
	Xor Eax, Eax	;Return (FALSE)
	Ret
EndU

OnECTimeDrvTestAfterCreate:
	UseData ECTimeDrvTestProcedure

	Call Simple_Init
	Invoke SendMessage, [hList], LB_RESETCONTENT, NULL, NULL
	;--
	Call Load_ECTDrv
	Call Open_File
	;--
	Ret
EndU

OnECTimeDrvTestCommand:
	UseData ECTimeDrvTestProcedure

	LoWord ([wParam])
	Cmp Ax, IDC_ECTIMEDRVTEST_BUTTON1
	Jne >
	HiWord ([wParam])
	Cmp Ax, BN_CLICKED
	Jne > L4
	Call Read_File
L2:	Mov Eax, TRUE
	Ret
:	Cmp Ax, IDC_ECTIMEDRVTEST_BUTTON2
	Jne > L4
	HiWord ([wParam])
	Cmp Ax, BN_CLICKED
	Jne > L4
	Call Write_File
	Jmp < L2
L4:	Ret
EndU

OnECTimeDrvTestClose:
	UseData ECTimeDrvTestProcedure

	;--
	Call Close_file
	Call UnLoad_ECTDrv
	;--
	Invoke IsModal, [hWnd]
	Or Eax, Eax		;Cmp Eax, FALSE
	Jz >
	Invoke EndModal, [hWnd], IDCANCEL
	Mov Eax, TRUE	;Return (TRUE)
:	Ret
EndU

Load_ECTDrv Frame
	Local hSCManager:D, hService:D
	Local acDriverPath[MAX_PATH]:B

	Invoke OpenSCManager, NULL, NULL, SC_MANAGER_CREATE_SERVICE
	Cmp Eax, NULL
	Jne >
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, TEXT("Open SCManager Err")
	Ret
:	Mov [hSCManager], Eax
	Invoke GetFullPathName, TEXT("ECTimeDriver.sys"), SizeOf acDriverPath, Addr acDriverPath, NULL
	Invoke CreateService, [hSCManager], TEXT("ECTimeDriver"), TEXT("EC SYS Driver"), \
						  SERVICE_START + DELETE, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START, \
						  SERVICE_ERROR_IGNORE, Addr acDriverPath, NULL, NULL, NULL, NULL, NULL
	Cmp Eax, NULL
	Jne >
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, TEXT("Create Service Err")
	Jmp > L2
:	Mov [hService], Eax
	Invoke StartService, [hService], 0, NULL
	Invoke CloseServiceHandle, [hService]
L2:	Invoke CloseServiceHandle, [hSCManager]
	Ret
EndF

UnLoad_ECTDrv Frame
	Local hSCManager:D, hService:D
	Local sService:SERVICE_STATUS

	Invoke OpenSCManager, NULL, NULL, SC_MANAGER_ALL_ACCESS
	Cmp Eax, NULL
	Jne >
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, TEXT("Open SCManager Err")
	Ret
:	Mov [hSCManager], Eax
	Invoke OpenService, [hSCManager], TEXT("ECTimeDriver"), SERVICE_ALL_ACCESS
	Cmp Eax, NULL
	Jne >
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, TEXT("Open Service Err")
	Jmp > L2
:	Mov [hService], Eax
	Invoke ControlService, [hService], SERVICE_CONTROL_STOP, Addr sService
	Invoke DeleteService, [hService]
	Invoke CloseServiceHandle, [hService]
L2:	Invoke CloseServiceHandle, [hSCManager]
    ;--
	Ret
EndF

Open_File:
	Cmp D[hFile], 0
	Je >
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, TEXT("Open File Err")
	Ret
:	Invoke CreateFile, TEXT("\\.\ECTimeDriver"), GENERIC_READ Or GENERIC_WRITE, \
					   FILE_SHARE_READ Or FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	Cmp Eax, INVALID_HANDLE_VALUE
	Je >
	Mov [hFile], Eax
	Ret
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, TEXT("Create File Err")
	Ret

Close_file:
	Cmp D[hFile], 0
	Je >
	Invoke CloseHandle, [hFile]
	Mov D[hFile], 0
	.EndIf
:	Ret

Read_File Frame
	Local BRet:D

	Push Ebx
	Push Ecx
	Push Edx
	Invoke SendMessage, [hList], LB_RESETCONTENT, NULL, NULL
	;---
	Invoke RtlZeroMemory, Addr TF, SizeOf TF
	Mov D[BRet], 0
	Invoke ReadFile, [hFile], Addr TF, SizeOf TF, Addr BRet, NULL
	;--
	Cmp D[BRet], 0
	Jle >
	Call ShowTimeDate
	;--
:	Invoke GetLocalTime, Addr S_T
	Movzx Ebx, W[S_T.wDay]
	Movzx Ecx, W[S_T.wMonth]
	Movzx Edx, W[S_T.wYear]
	Invoke wsprintf, Addr TMP_Buffer, TEXT("%u/%u/%u%s  -> In USER Mode"), Ebx, Ecx, Edx, Addr TAB
	Add Esp, 24
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, Addr TMP_Buffer
	Movzx Ebx, W[S_T.wHour]
	Movzx Ecx, W[S_T.wMinute]
	Movzx Edx, W[S_T.wSecond]
	Invoke wsprintf, Addr TMP_Buffer, TEXT("%u:%u:%u%s  -> In USER Mode"), Ebx, Ecx, Edx, Addr TAB
	Add Esp, 24
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, Addr TMP_Buffer
	Pop Edx
	Pop Ecx
	Pop Ebx
	Ret
EndF

Write_File Frame
	Local BRet:D

	Invoke SendMessage, [hList], LB_RESETCONTENT, NULL, NULL
	;---
	Mov D[BRet], 0
	Call SetTimeDate
	Or Eax, Eax
	Jnz >
	Invoke WriteFile, [hFile], Addr TF, SizeOf TF, Addr BRet, NULL
	Cmp D[BRet], SizeOf TF
	Je >
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, TEXT("Write File Err.")
:	Ret
EndF

Simple_Init:
	Invoke GetWindowItem, [App.Main], IDC_ECTIMEDRVTEST_LIST1
	Mov [hList], Eax
    Invoke GetWindowItem, [App.Main], IDC_ECTIMEDRVTEST_Y_
    Mov [Y_hwnd], Eax
    Invoke GetWindowItem, [App.Main], IDC_ECTIMEDRVTEST_MO_
    Mov [MO_hwnd], Eax
    Invoke GetWindowItem, [App.Main], IDC_ECTIMEDRVTEST_D_
    Mov [D_hwnd], Eax
    Invoke GetWindowItem, [App.Main], IDC_ECTIMEDRVTEST_H_
    Mov [H_hwnd], Eax
    Invoke GetWindowItem, [App.Main], IDC_ECTIMEDRVTEST_MI_
    Mov [MI_hwnd], Eax
    Invoke GetWindowItem, [App.Main], IDC_ECTIMEDRVTEST_S_
    Mov [S_hwnd], Eax
    ;--
    Mov Eax, Offset TABs
    Mov D[Eax], 60
    Mov D[Eax + 4], 120
    Invoke SendMessage, [hList], LB_SETTABSTOPS, 2, Addr TABs
    ;--
	Ret

ShowTimeDate:
	Movzx Eax, W[TF.Year]
	Invoke String, Eax, Addr TMP_Buffer, ecDecimal
	Invoke SetText, [Y_hwnd], Addr TMP_Buffer
	Movzx Eax, W[TF.Month]
	Invoke String, Eax, Addr TMP_Buffer, ecDecimal
	Invoke SetText, [MO_hwnd], Addr TMP_Buffer
	Movzx Eax, W[TF.Day]
	Invoke String, Eax, Addr TMP_Buffer, ecDecimal
	Invoke SetText, [D_hwnd], Addr TMP_Buffer

	Movzx Eax, W[TF.Hour]
	Invoke String, Eax, Addr TMP_Buffer, ecDecimal
	Invoke SetText, [H_hwnd], Addr TMP_Buffer
	Movzx Eax, W[TF.Minute]
	Invoke String, Eax, Addr TMP_Buffer, ecDecimal
	Invoke SetText, [MI_hwnd], Addr TMP_Buffer
	Movzx Eax, W[TF.Second]
	Invoke String, Eax, Addr TMP_Buffer, ecDecimal
	Invoke SetText, [S_hwnd], Addr TMP_Buffer
	Ret

SetTimeDate Frame
	Local ErrPtr[24]:B

    Invoke GetText, [Y_hwnd], Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    Cmp Ax, 1601
    Jg >
   	Invoke lstrcpy, Addr ErrPtr, TEXT("Year")
   	Jmp > STD_Sal
:	Mov [TF.Year], Ax
    Invoke GetText, [MO_hwnd], Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    Cmp Ax, 0
    Jg >
L2:	Invoke lstrcpy, Addr ErrPtr, TEXT("Month")
	Jmp > STD_Sal
:	Cmp Ax, 13
	Jge < L2
	Mov [TF.Month], Ax
    Invoke GetText, [D_hwnd], Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    Cmp Ax, 0
    Jg >
L4:	Invoke lstrcpy, Addr ErrPtr, TEXT("Day")
	Jmp > STD_Sal
:	Cmp Ax, 32
	Jge < L4
	Mov [TF.Day], Ax
    ;--
    Invoke GetText, [H_hwnd], Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    Cmp Ax, 0
    Jge >
L6:	Invoke lstrcpy, Addr ErrPtr, TEXT("Hour")
	Jmp > STD_Sal
:	Cmp Ax, 24
	Jge < L6
	Mov [TF.Hour], Ax
    Invoke GetText, [MI_hwnd], Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    Cmp Ax, 0
    Jge >
L8:	Invoke lstrcpy, Addr ErrPtr, TEXT("Minute")
	Jmp > STD_Sal
:	Cmp Ax, 60
	Jge < L8
	Mov [TF.Minute], Ax
    Invoke GetText, [S_hwnd], Addr TMP_Buffer
    Invoke Value, Addr TMP_Buffer
    And Eax, 0FFFFH
    Cmp Ax, 0
    Jge >
L10:
	Invoke lstrcpy, Addr ErrPtr, TEXT("Second")
   	Jmp > STD_Sal
:	Cmp Ax, 60
	Jge < L10
	Mov [TF.Second], Ax
    Mov Eax, 0        ; OK
	Ret
    ;---
STD_Sal:
	Invoke lstrcpy, Addr TMP_Buffer, Addr ErrPtr
	Invoke lstrcat, Addr TMP_Buffer, TEXT(" Invalid")
	Invoke SendMessage, [hList], LB_ADDSTRING, NULL, Addr TMP_Buffer
	Mov Eax, -1  ; Error
	Ret
	;----
EndF
